
int read_timeout (int s, char *data, int sizeofdata, int timeout)
{
  fd_set fdsetz;
  struct timeval tv;
  int nd;


  tv.tv_sec = timeout;
  tv.tv_usec = 0;

  FD_ZERO (&fdsetz);

  FD_SET (s, &fdsetz);

  nd = select (FD_SETSIZE, &fdsetz, NULL, NULL, &tv);
  if (nd <= 0)
    {

      return (-2);
    }


  if (FD_ISSET (s, &fdsetz))
    return (read (s, data, sizeofdata));

  return (-2);
}



int
ADMtelnet (int dasock)
{
  u_char buf[3];
  int r = 0;
 
 

  while (1)
    {
      memset (buf, 0, sizeof (buf));
      r = 0;
      r = read_timeout (dasock, buf, 1, 5);

      if (r == -2)
	{
	  printf ("\n<*> admtelnet () timeout :)\n<*> maybe the negoc is over!\n");
	  return (dasock);
	}
      if (r == -1)
	{
	  perror ("read");
	  close (dasock);
	  return (-1);
	}

      if (*buf == (unsigned int) 255)
	{
	  r = read_timeout (dasock, (buf + 1), 2, 3);

	  if (r == -2)
	    {
	      printf ("\n<*> admtelnet () timeout :)\n<*> maybe the negoc is over!\n");
	      return (dasock);
	    }
	  if (r == -1)
	    {
	      perror ("read");
	      close (dasock);
	      return (-1);
	    }

	  if (buf[1] == 253 || buf[1] == 251 || buf[1] == 254)
	    {
	      if (buf[1] == 251)
		buf[1] = 254;
	      else
		buf[1] = 252;
	      if (write (dasock, buf, 3) < 0)
		{
		  close (dasock);
		  return (-1);
		}

	      continue;
	    }

	}
      else
	{
	  return (dasock);
	}


    }

  close (dasock);
  return -1;
  
}
