void FATAL(char *fmt,...)
{
    	va_list ap;
    	va_start(ap, fmt);
#ifdef SYSLOG
	syslog(LOG_ERR,fmt,ap);
#endif	
    	fprintf(stderr, "[" APPNAME "] ");
    	vfprintf(stderr, fmt, ap);
    	fprintf(stderr, "\n");
    	fflush(stderr);
    	exit(1);
}

/* message de debuggage */
void DBG(char *fmt,...)
{
#ifdef DEBUG
    	va_list ap;
    	va_start(ap, fmt);
#ifdef SYSLOG	
	syslog(LOG_DEBUG,fmt,ap);
#endif
        fprintf(stderr, "[" APPNAME ":dbg] ");
	vfprintf(stderr,fmt,ap);
    	fprintf(stderr, "\n");
    	fflush(stderr);
#endif
}

/* message d'erreur */
void ERROR(char *fmt,...)
{
    	va_list ap;
	va_start(ap, fmt);
#ifdef SYSLOG
	syslog(LOG_WARNING,fmt,ap);
#endif
        fprintf(stderr, "[" APPNAME ":error] ");
    	vfprintf(stderr, fmt, ap);
    	fprintf(stderr, "\n");
    	fflush(stderr);
}

